/*
 *
 * Copyright (C)  1996 Jochen Karrer 
 *
 */
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <setjmp.h>
#include "fglib.h"
#include "tkmv1.h"
//#include "mv1lib.c"
#include "mv1.h"

static MV1_settings settings[] = {
	{
                "Packer",MV1_CONFIG_RADIO,0,4,
                { "8Bit","10Bit","8Bit_mod","16Bit_mod","32Bit_mod","" },
		MV1_InquirePixelMode,MV1_SelectPixelMode,
                NULL,MV1_INQUIRE_PIXELMODE,
                NULL,MV1_SELECT_PIXELMODE,

        },
	{
		"H_Start",MV1_CONFIG_INT,0,4095,
		{ "" },
		MV1_InquireHStart,MV1_SetHStart,
		NULL,MV1_INQUIRE_H_START,
		NULL,MV1_SET_H_START,

	},
	 {
                "V_Start",MV1_CONFIG_INT,0,4095,
                { "" },
		MV1_InquireVStart,MV1_SetVStart,
                NULL,MV1_INQUIRE_V_START,
                NULL,MV1_SET_V_START,

        },
	 {
                "H_End",MV1_CONFIG_INT,0,4095,
                { "" },
		MV1_InquireHEnd,MV1_SetHEnd,
                NULL,MV1_INQUIRE_H_END,
                NULL,MV1_SET_H_END,

         },
         {
                "V_End",MV1_CONFIG_INT,0,4095,
                { "" },
		MV1_InquireVEnd,MV1_SetVEnd,
                NULL,MV1_INQUIRE_V_END,
                NULL,MV1_SET_V_END,

        },
	{
                "Eq_Remove",MV1_CONFIG_INT,0,63,
                { "" },
		MV1_InquireEqRemove,MV1_SetEqRemove,
                NULL,MV1_INQUIRE_EQ_REMOVE,
                NULL,MV1_SET_EQ_REMOVE,

        },
	{ 	
		"Video_In" , MV1_CONFIG_RADIO,0,3,
		{ 	"Red_Cable", "Green_Cable", 
			"Blue_Cable", "Gray_Cable",""
		},
		MV1_InquireCVideoSource,MV1_SetCVideoSource,
		NULL,MV1_INQUIRE_CVIDEO_SOURCE,
		NULL,MV1_SET_CVIDEO_SOURCE
	},

	{
		"Sync_In",MV1_CONFIG_RADIO,0,3,
		{
			"Gray_Cable", "Black_Cable", 
			"Green_Cable", "Video",""
		},
		MV1_InquireCSyncSource,MV1_SetCSyncSource,
		NULL,MV1_INQUIRE_CSYNC_SOURCE,
		NULL,MV1_SET_CSYNC_SOURCE
	},

	{	
		"Clock_Source",MV1_CONFIG_RADIO,0,3,
		{
			"CSync","HSync","Ext","14MHz",""
		},
		MV1_InquireClockSource,MV1_SelectClockSource,
		NULL,MV1_INQUIRE_CLOCK_SOURCE,
		NULL,MV1_SELECT_CLOCK_SOURCE

	}, 
	
	 {
                "SyncStrip",MV1_CONFIG_RADIO,0,3,
                {
                        "5-10 kHz","10-20 kHz","20-40 kHz","40-64 kHz",""
                },
		MV1_InquireSyncStripRange,MV1_SelectSyncStripRange,
                NULL,MV1_INQUIRE_SYNC_STRIP_RANGE,
                NULL,MV1_SELECT_SYNC_STRIP_RANGE

        }, 
	 {
                "Shift_down",MV1_CONFIG_RADIO,0,1,
                {
                        "0_Bit","2_Bit",""
                },
		MV1_InquireADConvertor,MV1_SelectADConvertor,
                NULL,MV1_INQUIRE_SHIFT_DOWN,
                NULL,MV1_SET_SHIFT_DOWN

        },

	{
                "PLL_Phase",MV1_CONFIG_INT,0,255,
                { "" },
		MV1_InquirePLLPhaseTrim,MV1_SetPLLPhaseTrim,
                NULL,MV1_INQUIRE_PLL_PHASE_TRIM,
                NULL,MV1_SET_PLL_PHASE_TRIM
        },


	{	
		"A/D_Top",MV1_CONFIG_INT,0,255,
		{ "" },
		MV1_InquireADTopLevel,MV1_SetADTopLevel,
		NULL,MV1_INQUIRE_AD_TOP_LEVEL,
		NULL,MV1_SET_AD_TOP_LEVEL
	},	

	{
                "A/D_Bottom",MV1_CONFIG_INT,0,255,
                { "" },
		MV1_InquireADBottomLevel,MV1_SetADBottomLevel,
                NULL,MV1_INQUIRE_AD_BOTTOM_LEVEL,
		NULL,MV1_SET_AD_BOTTOM_LEVEL
        },
	{
                "Clamp_Level",MV1_CONFIG_INT,0,255,
                { "" },
		MV1_InquireClampLevel,MV1_SetClampLevel,
                NULL,MV1_INQUIRE_CLAMP_LEVEL,
                NULL,MV1_SET_CLAMP_LEVEL
        },
	{
                "Clamping",MV1_CONFIG_RADIO,0,2,
                { "No_Clamp","B_Porch","SyncTip","" },
		MV1_InquireClamping,MV1_SelectClamping,
                NULL,MV1_INQUIRE_CLAMPING,
                NULL,MV1_SELECT_CLAMPING
        },

	{
                "DC_Offset",MV1_CONFIG_INT,0,255,
                { "" },
		MV1_InquireDCOffset,MV1_SetDCOffset,
                NULL,MV1_INQUIRE_DC_OFFSET,
                NULL,MV1_SET_DC_OFFSET
        },
	{
                "Trigger",MV1_CONFIG_RADIO,0,1,
                { "internal","external","" },
		MV1_InquireExtTrigger,MV1_SetExtTrigger,
                NULL,MV1_INQUIRE_EXT_TRIGGER,
                NULL,MV1_SET_EXT_TRIGGER
        },
	{
                "Trig_Pol",MV1_CONFIG_RADIO,0,1,
                { "low","high","" },
		MV1_InquireTriggerPolarity,MV1_SetTriggerPolarity,
                NULL,MV1_INQUIRE_TRIGGER_POLARITY,
                NULL,MV1_SET_TRIGGER_POLARITY
        },
	{
                "Interlace",MV1_CONFIG_RADIO,0,1,
                { "0","1","" },
		MV1_InquireInterlace,MV1_SetInterlace,
                NULL,MV1_INQUIRE_INTERLACE,
                NULL,MV1_SET_INTERLACE
        },
	{
                "Cutoff_freq",MV1_CONFIG_INT,0,127,
                { "" },
		MV1_InquireFilterCutoff,MV1_SetFilterCutoff,
                NULL,MV1_INQUIRE_FILTER_CUTOFF,
                NULL,MV1_SET_FILTER_CUTOFF
        },
	 {
                "HF-Boost",MV1_CONFIG_INT,0,127,
                { "" },
		MV1_InquireHighFreqBoost,MV1_SetHighFreqBoost,
                NULL,MV1_INQUIRE_HIGH_FREQ_BOOST,
                NULL,MV1_SET_HIGH_FREQ_BOOST
        },
	 {
                "GP_0",MV1_CONFIG_RADIO,0,1,
                { "0","1","" },
		MV1_InquireGPBit0,MV1_SetGPBit0,
                NULL,MV1_INQUIRE_GP_BIT0,
                NULL,MV1_SET_GP_BIT0
        },
	 {
                "GP_1",MV1_CONFIG_RADIO,0,1,
                { "0","1","" },
		MV1_InquireGPBit1,MV1_SetGPBit1,
                NULL,MV1_INQUIRE_GP_BIT1,
                NULL,MV1_SET_GP_BIT1
        },
	{
                "LUT_Bank",MV1_CONFIG_INT,0,7,
                { "" },
		MV1_InquireLutBank,MV1_SelectLutBank,
                NULL,MV1_INQUIRE_LUT_BANK,
                NULL,MV1_SELECT_LUT_BANK
        },
	{
                "Grab",MV1_CONFIG_RADIO,0,1,
                { "disable","enable","" },
		MV1_InquireGrab,MV1_SetGrab,
                NULL,MV1_INQUIRE_GRAB,
                NULL,MV1_SET_GRAB
        },
	{
                "Start_Field",MV1_CONFIG_RADIO,0,2,
                { "even","odd","next","" },
		MV1_InquireStartField,MV1_SetStartField,
                NULL,MV1_INQUIRE_STARTFIELD,
                NULL,MV1_SET_STARTFIELD
        },
	{
                "Grab_flag",MV1_CONFIG_RADIO,0,1,
                { "single","continuos","" },
		MV1_InquireGrabFlag, MV1_SetGrabFlag,
                NULL,MV1_INQUIRE_GRABFLAG,
                NULL,MV1_SET_GRABFLAG
        },

	{
                "Frame_INT",MV1_CONFIG_RADIO,0,1,
                { "disable","enable","" },
		MV1_InquireFrameEndIrq,MV1_SetFrameEndIrq,
                NULL,MV1_INQUIRE_FRAME_END_IRQ,
                NULL,MV1_SET_FRAME_END_IRQ
        },
	{
                "Transfer_INT",MV1_CONFIG_RADIO,0,1,
                { "disable","enable","" },
		MV1_InquireTransferEndIrq,MV1_SetTransferEndIrq,
                NULL,MV1_INQUIRE_TRANSFER_END_IRQ,
                NULL,MV1_SET_TRANSFER_END_IRQ
        },
	
	{
                "FBKDIV",MV1_CONFIG_INT,64,2048,
                { "" },
		ICS_InquireFbkDiv,ICS_SetFbkDiv,
                NULL,ICS_INQUIRE_FBK_DIV,
                NULL,ICS_SET_FBK_DIV
        },
	 {
                "REFDIV",MV1_CONFIG_INT,1,1024,
                { "" },
		ICS_InquireRefDiv,ICS_SetRefDiv,
                NULL,ICS_INQUIRE_REF_DIV,
                NULL,ICS_SET_REF_DIV
        },

	{
                "REF_POL",MV1_CONFIG_RADIO,0,1,
                { "pos","neg","" },
		ICS_InquireRefPol,ICS_SetRefPol,
                NULL,ICS_INQUIRE_REF_POL,
                NULL,ICS_SET_REF_POL
        },
	{
                "VCO_GAIN",MV1_CONFIG_RADIO,0,7,
                { "10MHz/V","15MHz/V","20MHz/V","25MHz/V","45MHz/V",
		"60MHz/V","75MHz/V","90MHz/V","" },
		ICS_InquireVCOGain,ICS_SetVCOGain,
                NULL,ICS_INQUIRE_VCO_GAIN,
                NULL,ICS_SET_VCO_GAIN
        },
	{
                "PFD_GAIN",MV1_CONFIG_RADIO,0,7,
                { "0_2344uA/2Pi","0_9375uA/2Pi","3_75uA/2Pi","15_0uA/2Pi","1_875uA/2Pi",
                "7_500uA/2Pi","30_00uA/2Pi","120uA/2Pi","" },
		ICS_InquirePFDGain,ICS_SetPFDGain,
                NULL,ICS_INQUIRE_PFD_GAIN,
                NULL,ICS_SET_PFD_GAIN
        },
	 {
                "PHASE_DET",MV1_CONFIG_RADIO,0,1,
                { "Off","On", "" },
		ICS_InquirePden,ICS_SetPden,
                NULL,ICS_INQUIRE_PDEN,
                NULL,ICS_SET_PDEN
        },
	 {
                "CLK_SEL",MV1_CONFIG_RADIO,0,1,
                { "VCO","OUT1", "" },
		ICS_InquireClkSel,ICS_SetClkSel,
                NULL,ICS_INQUIRE_CLKSEL,
                NULL,ICS_SET_CLKSEL
        },
	{
                "OUT_PS",MV1_CONFIG_RADIO,0,3,
                { "8","4", "2","1","" },
		ICS_InquirePDA,ICS_SetPDA,
                NULL,ICS_INQUIRE_PDA,
                NULL,ICS_SET_PDA
        },
	{
                "FBK_PS",MV1_CONFIG_RADIO,0,3,
                { "8","4", "2","1","" },
		ICS_InquirePDB,ICS_SetPDB,
                NULL,ICS_INQUIRE_PDB,
                NULL,ICS_SET_PDB
        },
	{
                "Lead_Lag",MV1_CONFIG_RADIO,0,1,
                { "0","1","" },
		ICS_InquireLeadLag,ICS_SetLeadLag,
                NULL,ICS_INQUIRE_LEAD_LAG,
                NULL,ICS_SET_LEAD_LAG
        },
	{
                "Sync_Out",MV1_CONFIG_RADIO,0,1,
                { "CSync","HVSync","" },
		LM1882_InquireSyncOutput,LM1882_SelectSyncOutput,
                NULL,LM1882_INQUIRE_SYNC_OUTPUT,
                NULL,LM1882_SELECT_SYNC_OUTPUT
        },

	{
                "EqSerr_Out",MV1_CONFIG_RADIO,0,3,
                { "None","Double_I","Double_NI","Single_NI","" },
		LM1882_InquireEQSerr,LM1882_SelectEQSerr,
                NULL,LM1882_INQUIRE_EQSERR,
                NULL,LM1882_SELECT_EQSERR
        },
	{
                "VCSyncOut_Pol",MV1_CONFIG_RADIO,0,1,
                { "neg","pos","" },
		LM1882_InquireVCSyncPolarity,LM1882_SelectVCSyncPolarity,
                NULL,LM1882_INQUIRE_VCSYNC_POLARITY,
                NULL,LM1882_SELECT_VCSYNC_POLARITY
        },
	{
                "HSyncOut_Pol",MV1_CONFIG_RADIO,0,1,
                { "neg","pos","" },
		LM1882_InquireHSyncPolarity,LM1882_SelectHSyncPolarity,
                NULL,LM1882_INQUIRE_HSYNC_POLARITY,
                NULL,LM1882_SELECT_HSYNC_POLARITY
        },
	{
                "SyncGen_Lines",MV1_CONFIG_INT,0,4095,
                { "" },
		LM1882_InquireLinePerFrame,LM1882_SetLinePerFrame,
                NULL,LM1882_INQUIRE_LINE_PER_FRAME,
                NULL,LM1882_SET_LINE_PER_FRAME
        },
	{
                "SyncGen_Pixel",MV1_CONFIG_INT,0,4095,
                { "" },
		LM1882_InquirePixelPerLine,LM1882_SetPixelPerLine,
                NULL,LM1882_INQUIRE_PIXEL_PER_LINE,
                NULL,LM1882_SET_PIXEL_PER_LINE
        },
#if 0

	{
                "PulseMode",MV1_CONFIG_RADIO,0,1,
                { "1","2","" },
		MV11_InquirePulseMode,MV11_SetPulseMode,
                NULL,MV11_INQUIRE_PULSE_MODE,
                NULL,MV11_SET_PULSE_MODE
        },
	{
                "ModeControl",MV1_CONFIG_INT,0,7,
                { "" },
		MV11_InquireModeControl,MV11_SetModeControl,
                NULL,MV11_INQUIRE_MODE_CONTROL,
                NULL,MV11_SET_MODE_CONTROL
        },
	{
                "ParFrameRemove",MV1_CONFIG_RADIO,0,1,
                { "0","1","" },
		MV11_InquireParFrameRem,MV11_SelectParFrameRem,
                NULL,MV11_INQUIRE_PAR_FRAME_REMOVE,
                NULL,MV11_SELECT_PAR_FRAME_REMOVE
        },
	{
                "BypassCounter",MV1_CONFIG_RADIO,0,1,
                { "0","1","" },
		MV11_InquireBypassCounter,MV11_SetBypassCounter,
                NULL,MV11_INQUIRE_BYPASS_COUNTER,
                NULL,MV11_SET_BYPASS_COUNTER
        },
	{
                "MV11Counter",MV1_CONFIG_INT,0,255,
                { "" },
		MV11_InquireCounter, MV11_SetCounter,
                NULL,MV11_INQUIRE_COUNTER,
                NULL,MV11_SET_COUNTER
        },
	{
                "MV11TrigEnable",MV1_CONFIG_RADIO,0,1,
                { "0","1","" },
		MV11_InquireTrigEnable,MV11_SetTrigEnable,
                NULL,MV11_INQUIRE_TRIG_ENABLE,
                NULL,MV11_SET_TRIG_ENABLE
        },
	{
                "MV11TrigPol",MV1_CONFIG_RADIO,0,1,
                { "trailing","raising","" },
		MV11_InquireTrigPol,MV11_SetTrigPol,
                NULL,MV11_INQUIRE_TRIG_POL,
                NULL,MV11_SET_TRIG_POL
        },
	{
                "MV11_SET_LS_EXP",MV1_CONFIG_RADIO,0,1,
                { "0","1","" },
		MV11_InquireLsExp,MV11_SetLsExp,
                NULL,MV11_INQUIRE_LS_EXP,
                NULL,MV11_SET_LS_EXP
        },
	{
                "LDV_Pol",MV1_CONFIG_RADIO,0,1,
                { "non_inv","inv","" },
		MV11_InquireLDVPol,MV11_SetLDVPol,
                NULL,MV11_INQUIRE_LDV_POL,
                NULL,MV11_SET_LDV_POL
        },
	{
                "FDV_Pol",MV1_CONFIG_RADIO,0,1,
                { "non_inv","inv","" },
		MV11_InquireFDVPol,MV11_SetFDVPol,
                NULL,MV11_INQUIRE_FDV_POL,
                NULL,MV11_SET_FDV_POL
        },
	{
                "PCLK_Pol",MV1_CONFIG_RADIO,0,1,
                { "non_inv","inv","" },
		MV11_InquirePCLKPol,MV11_SetPCLKPol,
                NULL,MV11_INQUIRE_PCLK_POL,
                NULL,MV11_SET_PCLK_POL
        },
#endif 
	{
                "ShiftControl",MV1_CONFIG_RADIO,0,1,
                { "mv1000","mv1100","" },
		MV1_InquireTopShiftControl,MV1_SetTopShiftControl,
                NULL,MV1_INQUIRE_TOP_SC,
                NULL,MV1_SET_TOP_SC
        },




	
	 {
                "Int_Time",MV1_CONFIG_INT,0,8191,
                { "" },
		MV1_InquireIntegrationTime,MV1_SetIntegrationTime,
                NULL,MV1_INQUIRE_INTEGRATION_TIME,
                NULL,MV1_SET_INTEGRATION_TIME
        },
	 {
                "Integ_Mode",MV1_CONFIG_RADIO,0,2,
                { "negative","positive","none","" },
                CAM_InquireIntCtlMode,CAM_SetIntCtlMode,
                NULL,CAM_INQUIRE_INT_CTL_MODE,
                NULL,CAM_SET_INT_CTL_MODE
        },

	{ 
		"MstrEnable",MV1_CONFIG_RADIO,0,1,
                { "stop","go","" },
		MV1_InquireMasterEnable, MV1_SetMasterEnable,
                NULL,MV1_INQUIRE_MASTER_ENABLE,
                NULL,MV1_SET_MASTER_ENABLE
        },
	{ 
		"MstrLoop",MV1_CONFIG_RADIO,0,1,
                { "single","loop","" },
		MV1_InquireMasterLoop,MV1_SetMasterLoop,
                NULL,MV1_INQUIRE_MASTER_LOOP,
                NULL,MV1_SET_MASTER_LOOP
        },
	{ 
		"MstrWaitFrame",MV1_CONFIG_RADIO,0,1,
                { "nowait","wait","" },
		MV1_InquireMasterWaitFrame,MV1_SetMasterWaitFrame,
                NULL,MV1_INQUIRE_MASTER_WAIT_FRAME,
                NULL,MV1_SET_MASTER_WAIT_FRAME
        },
	{ 
		"FrameEnds",MV1_CONFIG_INT,0,MAX_INT,
                { "" },
		MV1_InquireFrameEndCount,NULL,
                NULL,MV1_INQUIRE_FRAME_END_COUNT,
                NULL,0
        },
	{ 
		"BadLists",MV1_CONFIG_INT,0,MAX_INT,
                { "" },
		MV1_InquireBadListCount,NULL,
                NULL,MV1_INQUIRE_BAD_LIST_COUNT,
                NULL,0
        },
	{ 
		"TransferEnds",MV1_CONFIG_INT,0,MAX_INT,
                { "" },
		MV1_InquireTransferEndCount,NULL,
                NULL,MV1_INQUIRE_TRANSFER_END_COUNT,
                NULL,0
        },
	{ 
		"test2",MV1_CONFIG_INT,0,65535,
                { "" },
		NULL,NULL,
                NULL,TEST2_GET,
                NULL,TEST2 
        },



	{ NULL,0,0,0,{NULL} }
};
int 
mv1_snap(MV1Ctrl *ctrlPtr,int argc, char *argv[]){
        Tcl_Interp *interp = ctrlPtr->interp;
	long wait=0;
        long time=0;
	while ((argc>0)&&argv[0][0] == '-'){
                int len = strlen(argv[0]);
                char c = argv[0][1];
                if (( c == 'w') && (strncmp(argv[0],"-wait",len) == 0)) {
                        wait = 1;
                }
                else if( (c =='t') && (strncmp(argv[0],"-time",len) == 0)) {
                        if((argc > 1) && Tcl_ExprLong(interp,argv[1],&time) == TCL_OK){
                                argc--; argv++;
                        }
                        else {
                                interp->result = "-time needs an exposure time in number of frames";
                                return TCL_ERROR;
                        }

                }
                argv++; argc--;
        }
	if(argc > 0){
		Tcl_AppendResult(interp,"wrong argument",argv[0],
		": possible arguments are -wait -time time",NULL);
		return TCL_ERROR;	
	}

	if(time) {
		MV1_SetIntegrationTime(time,ctrlPtr->bdCtrl);
	}
        interp->result[0]=0;
        if( MV1_Snap(ctrlPtr->bdCtrl,1)!=0) 
                return TCL_ERROR;
	if(wait){
//		wait until snap done	
	}
        return TCL_OK; 

}
int
mv1_grab(MV1Ctrl *ctrlPtr,int argc, char *argv[]){
	long time = -1;
	long reset = 0;
	long wait = 0;
	Tcl_Interp *interp = ctrlPtr->interp;	
	while ((argc>0)&&argv[0][0] == '-'){
                int len = strlen(argv[0]);
                char c = argv[0][1];
                if (( c == 'r') && (strncmp(argv[0],"-reset",len) == 0)) {
			reset = 1;
                }
                if (( c == 'w') && (strncmp(argv[0],"-wait",len) == 0)) {
			wait = 1;
		}
                else if( (c =='t') && (strncmp(argv[0],"-time",len) == 0)) {
        		if((argc > 1) && Tcl_ExprLong(interp,argv[1],&time) == TCL_OK){
                                argc--; argv++;
                        }
                        else {
                                interp->result = "-time needs an exposure time in number of frames";
                                return TCL_ERROR;
                        }

                }
                argv++; argc--;
        }
	if(argc > 0){
		Tcl_AppendResult(interp,"wrong argument",argv[0],
		": possible arguments are -wait -reset -time time",NULL);
		return TCL_ERROR;	
	}

        if(time>0){
                MV1_SetIntegrationTime(time,ctrlPtr->bdCtrl);
        }
	if(reset){
		MV1_ResetIntegrationTime(ctrlPtr->bdCtrl);
	}
//	MV1_SetGrabFlag(MV1_SINGLE_GRAB,ctrlPtr->bdCtrl);
//	MV1_SetGrabFlag(MV1_CONT_GRAB,ctrlPtr->bdCtrl);
        MV1_Snap(ctrlPtr->bdCtrl,0);  // continuous
	if(wait) {
		MV1_WaitFrameEnd(ctrlPtr->bdCtrl);
		MV1_WaitFrameEnd(ctrlPtr->bdCtrl);
	}
	return TCL_OK;
}
int
MV1Cmd (ClientData clientData,Tcl_Interp *interp,int argc,char *argv[]){
	char c;
        int length;
        MV1Ctrl *ctrl = (MV1Ctrl *)clientData;
        if(argc<2){
                Tcl_AppendResult(interp, "wrong # args: should be \"",
                argv[0], " command  ?args?\"", NULL);
                return TCL_ERROR;
        }
        c = argv[1][0];
        length = strlen(argv[1]);
	if( c == 's' && (strncmp(argv[1],"save",length) == 0)){
		mv1_Save(ctrl,argc-2,argv+2);	
        }
	else if(c == 's' && (strncmp(argv[1],"snap",length) == 0)) {
		return mv1_snap(ctrl,argc-2,argv+2);
	}
	else if(c == 'g' && (strncmp(argv[1],"grab",length) == 0)) {
		return mv1_grab(ctrl,argc-2,argv+2);
	}

        return TCL_OK;
}

/*
 * ---------------------------------------------------------------------------
 *  
 * MV1_ControlInit --
 *
 * 	Create a command for opening a mv1000
 *
 * ---------------------------------------------------------------------------
 */  
int MV1_ControlInit(Tcl_Interp *interp){
	Tcl_CreateCommand(interp,"mv1000",MV1Open,(ClientData)NULL,
                                (Tcl_CmdDeleteProc *) NULL);
        return TCL_OK;
}
int
MV1_ReadFromDevice(MV1_settings *s,MV1Ctrl *ctrlPtr){
	int ret;
        if(s->get) {
                ret = (s->get)(ctrlPtr);
        }
	else if(s->libget) {
		ret = (s->libget)(ctrlPtr->bdCtrl);
	}
	else if(s->g_ioctl){ 
//		fprintf(stderr,"ioctl %s!!!!\n",s->name);
                ret = ioctl(ctrlPtr->bdCtrl->ctrl_fd,s->g_ioctl);
        }
	else ret = 0;
	if((ret > s->to)|| (ret < s->from) ) {
		fprintf(stderr,"fatal error: read value out of range: %s, %d\n",s->name,ret);
		fprintf(stderr,"get %p,libget %p,ioctl %d:\n",s->get,s->libget,s->g_ioctl);
		return s->from;
	}
	return ret;
}
int 
MV1_WriteToDevice(int value,MV1_settings *s,MV1Ctrl *ctrlPtr){
	if((value > s->to) || (value < s->from) )
		return -1;
        if(s->set){ 
                return (s->set)(ctrlPtr,(double) value );
        }
	else if(s->libset) {
		return (s->libset)(value,ctrlPtr->bdCtrl);
	}
	else if(s->s_ioctl) {
		fprintf(stderr,"ioctl !!!!\n");
                return ioctl(ctrlPtr->bdCtrl->ctrl_fd,s->s_ioctl,value);
        }
	else return 0;
}
inline int
MV1_GetSettingPtr(MV1Ctrl *ctrlPtr, char *name,MV1_settings **s) {	
	Tcl_HashEntry *entryPtr;
	entryPtr = Tcl_FindHashEntry(&(ctrlPtr->nameHash), name);
        *s = (MV1_settings *)Tcl_GetHashValue(entryPtr); 
	return 0;
}
/*
 * ------------------------------------------------------------------
 *
 *  MV1_RereadRadio --
 *
 *      Read a value from the Devicedriver, and set the value From
 *      the list to the variable
 *
 *
 * ------------------------------------------------------------------
 */
void MV1_RereadRadio(MV1Ctrl *ctrlPtr,MV1_settings *s) {
        int index;
	index = MV1_ReadFromDevice(s,ctrlPtr);
        Tcl_SetVar2(ctrlPtr->interp,ctrlPtr->name,s->name,
                s->valuelist[index], TCL_GLOBAL_ONLY);
}
void MV1_RereadInt(MV1Ctrl *ctrlPtr,MV1_settings *s) {
        int i;
	char value[30];
	i=MV1_ReadFromDevice(s,ctrlPtr);
	sprintf(value,"%d",i);
        Tcl_SetVar2(ctrlPtr->interp,ctrlPtr->name,s->name,
                value, TCL_GLOBAL_ONLY);
}


/*
 * --------------------------------------------------------------------
 *
 * MV1_SetRadioVarCmd --
 *
 *	Handles the writes to traced radio-vars
 *
 * --------------------------------------------------------------------
 */
char *
MV1_RadioSetCmd(ClientData clientData,Tcl_Interp 
        *interp,char *name1,char *name2, int flags) {
	MV1Ctrl *ctrlPtr = (MV1Ctrl *)clientData;
	int i;
	char *value;
	MV1_settings *s;
	if(name2 == NULL) {
                return  "is an array";
        }
	value = Tcl_GetVar2(interp,name1,name2,flags & TCL_GLOBAL_ONLY);
	MV1_GetSettingPtr(ctrlPtr,name2,&s);
	if(!s) printf("Fatal error in file %s, line %d",__FILE__,__LINE__);
	 
	/* To lazy for Hash Tables */
	for(i=0;s->valuelist[i];i++) {
		if(!strcmp(s->valuelist[i],value))
			break;
	}
	if(!s->valuelist[i]) {
		/*Tcl_SetVar2(interp,name1,name2,"oldValue",flags & TCL_GLOBAL_ONLY);*/
		return "value not possible";
	}
	MV1_WriteToDevice(i,s,ctrlPtr);
	return NULL;
}
char *
MV1_RadioGetCmd(ClientData clientData,Tcl_Interp 
        *interp,char *name1,char *name2, int flags) {
        MV1Ctrl *ctrlPtr = (MV1Ctrl *)clientData;
        int i;
        MV1_settings *s;
        if(name2 == NULL) {
                return  "is an array";
        }
	MV1_GetSettingPtr(ctrlPtr,name2,&s);
        i = MV1_ReadFromDevice(s,ctrlPtr);
	Tcl_SetVar2(interp,name1,name2,s->valuelist[i],flags & TCL_GLOBAL_ONLY);
        return NULL;
}

char *
MV1_IntSetCmd(ClientData clientData,Tcl_Interp 
        *interp,char *name1,char *name2, int flags) {

        MV1Ctrl *ctrlPtr = (MV1Ctrl *)clientData;
	long l;
	char *value;
        MV1_settings *s;
        if(name2 == NULL) {
                return  "is an array";
        }
	value = Tcl_GetVar2(interp,name1,name2,flags & TCL_GLOBAL_ONLY);
        MV1_GetSettingPtr(ctrlPtr,name2,&s);
        if(!s) fprintf(stderr,"Fatal error in file %s, line %d",__FILE__,__LINE__);
	if(Tcl_ExprLong(ctrlPtr->interp,value,&l)!=TCL_OK) {
		return NULL;
	}
	MV1_WriteToDevice(l,s,ctrlPtr);
        return NULL;

}
char *
MV1_IntGetCmd(ClientData clientData,Tcl_Interp 
        *interp,char *name1,char *name2, int flags) {

        MV1Ctrl *ctrlPtr = (MV1Ctrl *)clientData;
        long l;
        char value[30];
        MV1_settings *s;
        if(name2 == NULL) {
                return  "is an array";
        }
        MV1_GetSettingPtr(ctrlPtr,name2,&s);
        if(!s) fprintf(stderr,"Fatal error in file %s, line %d",__FILE__,__LINE__);
        l = MV1_ReadFromDevice(s,ctrlPtr);
	sprintf(value,"%ld",l);
	Tcl_SetVar2(interp,name1,name2,value,flags & TCL_GLOBAL_ONLY);
        return NULL;

}

/* 
 * ------------------------------------------------------------------
 *
 *  MV1_EventProc --
 *
 *	Handle Events from the Devicedriver
 *
 * ------------------------------------------------------------------
 */
void
MV1_EventProc(ClientData clientData,int mask) {
	MV1Ctrl *ctrlPtr = (MV1Ctrl *) clientData;
	MV1_settings *s;
	Tcl_HashEntry *entryPtr;
	MV1_Event event;
	while(MV1_GetEvent(&event,ctrlPtr->bdCtrl)>0){
		entryPtr = Tcl_FindHashEntry(&(ctrlPtr->s_ioctlHash),(u_char *)(int)event);
		if(!entryPtr) {
//			fprintf(stderr,"event not found %d\n",event); 
			return ;
		}
		s = (MV1_settings *)Tcl_GetHashValue(entryPtr);
		if(s->type & MV1_CONFIG_RADIO) {
			MV1_RereadRadio(ctrlPtr,s);
		}
		else if(s->type & MV1_CONFIG_INT) {
                        MV1_RereadInt(ctrlPtr,s);
                }
		else {
			printf("unknown event type\n");
		}
	}
}
/*
 * ---------------------------------------------------------------------
 *
 * MV1_CreateVars --
 *
 *	Create the variables which belong to a 
 *	connection to a framegrabber
 *
 * ---------------------------------------------------------------------
 */
void MV1_CreateVars(char *name,MV1Ctrl *ctrlPtr) {
	Tcl_Interp *interp = ctrlPtr->interp;
	MV1_settings *s = ctrlPtr->settings;
	char st[strlen(name)+30];
	char *list;
	int i,dummy,j = 0;
	double d;
	Tcl_HashEntry *entryPtr;

	Tcl_InitHashTable(&(ctrlPtr->nameHash),TCL_STRING_KEYS);
	Tcl_InitHashTable(&(ctrlPtr->s_ioctlHash),TCL_ONE_WORD_KEYS);
	while( s->name ) {
		entryPtr = Tcl_CreateHashEntry(&(ctrlPtr->nameHash),s->name,&dummy);
		Tcl_SetHashValue(entryPtr,(ClientData)s);
		entryPtr = Tcl_CreateHashEntry(&(ctrlPtr->s_ioctlHash),(char*)(s->s_ioctl),&dummy);
		Tcl_SetHashValue(entryPtr,(ClientData)s);
/*		printf("added %d\n",s->s_ioctl); */
		d = MV1_ReadFromDevice(s,ctrlPtr);
		i = (int) d;
//		printf("%s, got %f\n",(*s).name,d);
		if(s->type & MV1_CONFIG_RADIO) {
			Tcl_SetVar2(interp,name,(*s).name,
				s->valuelist[i],TCL_GLOBAL_ONLY);
			sprintf(st,"%s%s",name,":options");
			for(j=0;*(s->valuelist[j]);j++) ;
			list =Tcl_Merge(j,s->valuelist); 
			Tcl_SetVar2(interp,st,s->name ,
			list, TCL_GLOBAL_ONLY);
			free(list);
			Tcl_TraceVar2(interp,name,s->name,TCL_TRACE_WRITES,
                                      MV1_RadioSetCmd,(ClientData)ctrlPtr);
			Tcl_TraceVar2(interp,name,s->name,TCL_TRACE_READS,
                                      MV1_RadioGetCmd,(ClientData)ctrlPtr);

			
		}
		if(s->type & ( MV1_CONFIG_BOOL )) {
			sprintf(st,"%s%s",name,":bool");
	
			Tcl_SetVar2(interp,st,s->name,
				"pferd",TCL_GLOBAL_ONLY);
		}
		if(s->type & (MV1_CONFIG_DOUBLE | MV1_CONFIG_INT)) {
	
		/* Create the contents of the variable */

			if(s->type & MV1_CONFIG_DOUBLE) {
                                 sprintf(st,"%f",d);
                        }
                        else {
                                sprintf(st,"%d",i);
                        }
			Tcl_SetVar2(interp,name,s->name,
                                st,TCL_GLOBAL_ONLY);
			Tcl_TraceVar2(interp,name,s->name,TCL_TRACE_WRITES,
                                      MV1_IntSetCmd,(ClientData)ctrlPtr);
			Tcl_TraceVar2(interp,name,s->name,TCL_TRACE_READS,
                                      MV1_IntGetCmd,(ClientData)ctrlPtr);


		/* Create the type variable  */

			if(s->type & MV1_CONFIG_DOUBLE) {
				 sprintf(st,"%s%s",name,":double");
			}
			else {
				sprintf(st,"%s%s",name,":int");
			}
			Tcl_SetVar2(interp,st,s->name ,
                        "pferd", TCL_GLOBAL_ONLY);

		}
		s++;
	}
	
}
/*
 * ----------------------------------------------------------------
 *
 * MV1Open --
 *
 *      Creates a new connection to a MV1000.
 * 
 * ----------------------------------------------------------------
 */

int 
MV1Open (ClientData clientData,Tcl_Interp *interp,int argc,char *argv[]){
	MV1Ctrl *ctrlPtr = NULL;	
	int result = TCL_OK;
	if(argc <3) {
                sprintf(interp->result,"not enough arguments: should be: ...");
                return TCL_ERROR;
        }
	ctrlPtr = (MV1Ctrl*) calloc(1,sizeof(MV1Ctrl));
        if(ctrlPtr == NULL) {
                interp->result = "Not enough memory for MV-Control";
                return TCL_ERROR;
        }
	ctrlPtr->name = NULL;
	ctrlPtr->bdCtrl = NULL;
//	ctrlPtr->bdCtrl = (MV1_Ctrl *)calloc(1,sizeof(MV1_Ctrl));
//	if(ctrlPtr->bdCtrl == NULL) {
//              interp->result = "Not enough memory for MV-Control";
//              result = TCL_ERROR;
//		goto error;
//	}
	ctrlPtr->settings = settings;
//	ctrlPtr->bdCtrl->ctrl_fd = open(argv[2],O_RDWR|O_NONBLOCK);
	if((ctrlPtr->bdCtrl = MV1_Open(0))==NULL) {
		interp->result = "can't open framegrabber"; 
		return TCL_ERROR;
	}
	fcntl(ctrlPtr->bdCtrl->ctrl_fd,F_SETFL,O_NONBLOCK);
//	if(ctrlPtr->bdCtrl->ctrl_fd < 0){
//		Tcl_AppendResult(interp,"can't open ",argv[2],NULL);
//		result = TCL_ERROR;
//		goto error;
//	} 
	if( (ctrlPtr->name = strdup(argv[1]) ) == NULL){
                interp->result = "Not enough memory for MV-Control";
                result = TCL_ERROR;
                goto error;
        }
//	strcpy(ctrlPtr->name,argv[1]);

	ctrlPtr->interp = interp;
	Tcl_CreateCommand(interp,argv[1],MV1Cmd,(ClientData) ctrlPtr,(Tcl_CmdDeleteProc *) NULL);
	MV1_CreateVars(argv[1],ctrlPtr);
	Tk_CreateFileHandler(ctrlPtr->bdCtrl->ctrl_fd,TK_READABLE,MV1_EventProc,
                                (ClientData) ctrlPtr);

	verifyGrabMachine((ClientData) ctrlPtr);	
error:
	if(result == TCL_ERROR) {
		if(ctrlPtr->name) free(ctrlPtr->name);
		if(ctrlPtr->bdCtrl) free(ctrlPtr->bdCtrl);
		if(ctrlPtr) free(ctrlPtr);
	}	
	return result;
}
/*
 *
 *
 */

void verifyGrabMachine(ClientData clientData) {
	MV1Ctrl *ctrlPtr = (MV1Ctrl*) clientData;
	MV1_Ctrl *ctrl = ctrlPtr->bdCtrl;
	int t;
	static int flag = 0;
	Tcl_CreateTimerHandler(1000,verifyGrabMachine,ctrlPtr);
	if((t = MV1_InquireRestTime(ctrl)) > 24) {
		static char rtime[20];
		flag = 1;
		sprintf(rtime,"%d",t/25);
		Tcl_SetVar2(ctrlPtr->interp,ctrlPtr->name,"rest_time",rtime,TCL_GLOBAL_ONLY);
	}
	else {
		if(flag) {
			Tcl_SetVar2(ctrlPtr->interp,ctrlPtr->name,"rest_time","",TCL_GLOBAL_ONLY);
			flag = 0;
		}
	}
	if(MV1_InquireTimeSinceLastInt(ctrl) > 50) {
		if( MV1_InquireFrameEndIrq(ctrl) && 
			MV1_InquireGrab(ctrl) && MV1_InquireGrabFlag(ctrl) ) {
//			MV1_SetGrab(0,ctrl);
//			MV1_SetGrab(1,ctrl);
//			MV1_SetFrameEndIrq(1,ctrl);
			flag = 1;
			Tcl_SetVar2(ctrlPtr->interp,ctrlPtr->name,"rest_time","No Signal",TCL_GLOBAL_ONLY);
		}

	}
}

/*      
 * --------------------------------------------------------------------
 *
 * Here the tklib for the mv1000 starts 
 *
 * --------------------------------------------------------------------
 */
int
mv1_Save(MV1Ctrl *ctrl,int argc,char *argv[]){
	Tcl_Interp *interp = ctrl->interp;
	int format = FORMAT_PGM; 
	char *com="";
	int quality = 85;
	int append = 0;
	int zoom = 0;
	int xsize,ysize;
	MV1_Frame frame;
	FILE * outfile ;
	char *buf;

	MV1_InquireFrame(&frame,ctrl->bdCtrl);
	xsize = frame.dx;
   	ysize = frame.dy;

	if(!argc){
		interp->result = "to few arguments to save";
		return TCL_ERROR;
	}
	while ((argc>0)&&argv[0][0] == '-'){
		int len = strlen(argv[0]);
		char c = argv[0][1];
		if (( c == 'p') && (strncmp(argv[0],"-pgm",len) == 0)) {
			format = FORMAT_PGM;
		}
		else if( (c == 'j') &&  (strncmp(argv[0],"-jpg",len) == 0)) {
			format = FORMAT_JPG;
		}
		else if((c == 'a') && (strncmp(argv[0],"-append",len) == 0)) {
			append = 1;
		}
		else if(((c == 'z') && strncmp(argv[0],"-zoom",len) == 0)) {
			zoom = 1;
		}
		else if( (c =='q') && (strncmp(argv[0],"-quality",len) == 0)) {
			if(argc>1) {	
				sscanf(argv[1],"%d",&quality);
				argc--; argv++;
				if(quality > 100 || quality < 0) {
					quality = 75;
				}
			}
			else {
				interp->result = "-quality needs a numerical value (0-100)";
				return TCL_ERROR;
			}
			
		}
		else if( (c == 'c') && (strncmp(argv[0],"-comment",len) == 0)) {
			if (argc >1){
				com = argv[1];
				argc--; argv++;
			}
			else {
                                interp->result = "-comment needs a value";
                                return TCL_ERROR;
                        }
			
		}
		argv++; argc--;	
	}
	if(!argc){
		interp->result = "to few arguments to save";
		return TCL_ERROR;
	}
	else if(argc > 1) {
		interp->result = "the filename is not the last argument";
		return TCL_ERROR;
	}	
	if(append)
		outfile = fopen(argv[0],"a" );
	else 
		outfile = fopen(argv[0],"w" );

	if(outfile ==NULL ) {
		Tcl_AppendResult(interp,"can't save to:"
                ,argv[0],(char*)NULL);
		return TCL_ERROR;
	}
	MV1_SetZoom(ctrl->bdCtrl,zoom);
	xsize >>=zoom;
	ysize >>=zoom;
	buf = malloc(xsize*ysize);
	if(buf==NULL){
		interp->result = "out of memory";
		return TCL_ERROR;
	}	
	lseek(ctrl->bdCtrl->raw_fd,0,SEEK_SET);
  	read(ctrl->bdCtrl->raw_fd,buf,xsize*ysize);

	switch (format) {
                case FORMAT_PGM:
                        fprintf(outfile,"P5\n#%s\n%d %d\n255\n",com,xsize,ysize);
                case FORMAT_RAW8: 
                        fwrite(buf,1,xsize*ysize,outfile);
                        break; 
		case FORMAT_JPG:
			FG_WriteJPEGFile((JSAMPLE*)buf,com,xsize,ysize,outfile,quality);
			break;
        }
	fclose(outfile);
	free(buf);
	return TCL_OK;
}

/*
 *
 */
int mv1_Forbidden(MV1Ctrl *ctrl,double x) {
	fprintf(stderr,"not allowed to modify\n");
	return 0;
}
